#! /usr/bin/env python
#
# Copyright INRA-URGI 2009-2010
# 
# This software is governed by the CeCILL license under French law and
# abiding by the rules of distribution of free software. You can use,
# modify and/ or redistribute the software under the terms of the CeCILL
# license as circulated by CEA, CNRS and INRIA at the following URL
# "http://www.cecill.info".
# 
# As a counterpart to the access to the source code and rights to copy,
# modify and redistribute granted by the license, users are provided only
# with a limited warranty and the software's author, the holder of the
# economic rights, and the successive licensors have only limited
# liability.
# 
# In this respect, the user's attention is drawn to the risks associated
# with loading, using, modifying and/or developing or reproducing the
# software by the user in light of its specific status of free software,
# that may mean that it is complicated to manipulate, and that also
# therefore means that it is reserved for developers and experienced
# professionals having in-depth computer knowledge. Users are therefore
# encouraged to load and test the software's suitability as regards their
# requirements in conditions enabling the security of their systems and/or
# data to be ensured and, more generally, to use and operate it in the
# same conditions as regards security.
# 
# The fact that you are presently reading this means that you have had
# knowledge of the CeCILL license and that you accept its terms.
#
"""Convert a pseudo-FASTQ file to QUAL files"""

import os
from optparse import OptionParser
from SMART.Java.Python.misc.Progress import *
from math import *

if __name__ == "__main__":
    
    # parse command line
    description = "Wrong FastQ to Qual v1.0.1: Convert a pseudo-FastQ (i.e. a FastQ file with a wrong format) into a Qual file. [Category: Personnal]"

    parser = OptionParser(description = description)
    parser.add_option("-i", "--input",            dest="inputFileName",         action="store",                                                type="string", help="input file [compulsory] [format: file in FASTQ format]")
    parser.add_option("-o", "--output",         dest="outputFileName",        action="store",                                                type="string", help="output file [compulsory] [format: output file in QUAL format]")
    parser.add_option("-v", "--verbosity",    dest="verbosity",                 action="store",            default=1,                type="int",        help="trace level [format: int] [default: 1]")
    (options, args) = parser.parse_args()

    inputFile             = open(options.inputFileName)
    outputFastaFile = open("%s.fasta" % (options.outputFileName), "w")
    outputQualFile    = open("%s.qual" % (options.outputFileName), "w")
    
    inSequence     = False
    inQuality        = True
    sequenceName = None
    for line in inputFile:
        line = line.strip()
        if line[0] == "@":
            if inQuality == False:
                sys.exit("Quality of %s is missing" % (sequenceName))
            inSequence     = True
            inQuality        = False
            sequenceName = line[1:]
            outputFastaFile.write(">%s\n" % (sequenceName))
        elif line[0] == "+":
            if inSequence == False:
                sys.exit("Sequence of %s is missing" % (line[1:]))
            inSequence     = False
            inQuality        = True
            if sequenceName != line[1:]:
                sys.exit("Names in sequence and qual are different (%s, %s)" % (sequenceName, line[1:]))
            outputQualFile.write(">%s\n" % (sequenceName))
        else:
            if inSequence:
                outputFastaFile.write("%s\n" % (line))
            elif inQuality:
                outputQualFile.write("%s\n" % (line))
    
    inputFile.close()
    outputFastaFile.close()
    outputQualFile.close()
